diff --git a/lib389/changelog.py b/lib389/changelog.py
new file mode 100644
index 0000000..53c5592
--- /dev/null
+++ b/lib389/changelog.py
@@ -0,0 +1,96 @@
+'''
+Created on Jan 6, 2014
+
+@author: tbordaz
+'''
+
+import ldap
+import os
+from lib389 import DirSrv, Entry, InvalidArgumentError
+from lib389._constants import *
+from lib389.properties import *
+
+
+class Changelog(object):
+    proxied_methods = 'search_s getEntry'.split()
+
+    def __init__(self, conn):
+        """@param conn - a DirSrv instance"""
+        self.conn = conn
+        self.log = conn.log
+
+    def __getattr__(self, name):
+        if name in Changelog.proxied_methods:
+            return DirSrv.__getattr__(self.conn, name)
+
+    def list(self, suffix=None, changelogdn=None):
+        if not changelogdn:
+            raise InvalidArgumentError("changelog DN is missing")
+        
+        base  = changelogdn
+        filtr = "(objectclass=extensibleobject)"
+            
+        # now do the effective search
+        ents = self.conn.search_s(base, ldap.SCOPE_BASE, filtr)
+        return ents
+        
+    def create(self, dbname=DEFAULT_CHANGELOG_DB):
+        """Add and return the replication changelog entry.
+
+            If dbname starts with "/" then it's considered a full path,
+            otherwise it's relative to self.dbdir
+        """
+        dn = DN_CHANGELOG
+        attribute, changelog_name = dn.split(",")[0].split("=", 1)
+        dirpath = os.path.join(self.conn.dbdir, dbname)
+        entry = Entry(dn)
+        entry.update({
+            'objectclass': ("top", "extensibleobject"),
+            CHANGELOG_PROPNAME_TO_ATTRNAME[CHANGELOG_NAME]: changelog_name,
+            CHANGELOG_PROPNAME_TO_ATTRNAME[CHANGELOG_DIR]:  dirpath
+        })
+        self.log.debug("adding changelog entry: %r" % entry)
+        self.changelogdir = dirpath
+        try:
+            self.conn.add_s(entry)
+        except ldap.ALREADY_EXISTS:
+            self.log.warn("entry %s already exists" % dn)
+        return(dn)
+            
+    def delete(self, changelogdn=None):
+        raise NotImplemented
+    
+    def setProperties(self, changelogdn=None, properties=None):
+        if not changelogdn:
+            raise InvalidArgumentError("changelog DN is missing")
+        
+        ents = self.changelog.list(changelogdn=changelogdn)
+        if len(ents) != 1:
+            raise ValueError("Changelog entry not found: %s" % changelogdn)
+        
+        # check that the given properties are valid
+        for prop in properties:
+            # skip the prefix to add/del value
+            if not inProperties(prop, CHANGELOG_PROPNAME_TO_ATTRNAME):
+                raise ValueError("unknown property: %s" % prop)
+        
+        # build the MODS
+        mods = []
+        for prop in properties:
+            # take the operation type from the property name
+            val = rawProperty(prop)
+            if str(prop).startswith('+'):
+                op = ldap.MOD_ADD
+            elif str(prop).startswith('-'):
+                op = ldap.MOD_DELETE
+            else:
+                op = ldap.MOD_REPLACE
+            
+            mods.append((op, REPLICA_PROPNAME_TO_ATTRNAME[val], properties[prop]))
+            
+        # that is fine now to apply the MOD
+        self.conn.modify_s(ents[0].dn, mods)
+        
+
+    def getProperties(self, changelogdn=None, properties=None):
+        raise NotImplemented
\ No newline at end of file
diff --git a/lib389/properties.py b/lib389/properties.py
index 07b4d0d..4b5184a 100644
--- a/lib389/properties.py
+++ b/lib389/properties.py
@@ -4,6 +4,7 @@ Created on Dec 5, 2013
 @author: tbordaz
 '''
 
+
 ####################################
 # 
 # Properties supported by the server
@@ -112,29 +113,140 @@ BACKEND_PROPNAME_TO_ATTRNAME = {BACKEND_SUFFIX:        'nsslapd-suffix',
 
 ####################################
 # 
+# Properties of a replica
+#
+####################################
+
+REPLICA_SUFFIX           = 'suffix'
+REPLICA_ID               = 'rid'
+REPLICA_TYPE             = 'type'
+REPLICA_LEGACY_CONS      = 'legacy'
+REPLICA_BINDDN           = 'binddn'
+REPLICA_PURGE_INTERVAL   = 'purge-interval'
+REPLICA_PURGE_DELAY      = 'purge-delay'
+REPLICA_REFERRAL         = 'referral'
+REPLICA_FLAGS            = 'flags'
+
+REPLICA_OBJECTCLASS_VALUE = 'nsds5Replica'
+
+REPLICA_PROPNAME_TO_ATTRNAME = {
+                                REPLICA_SUFFIX:           'nsds5replicaroot',
+                                REPLICA_ID:               'nsds5replicaid',
+                                REPLICA_TYPE:             'nsds5replicatype',
+                                REPLICA_LEGACY_CONS:      'nsds5replicalegacyconsumer',
+                                REPLICA_BINDDN:           'nsds5replicabinddn',
+                                REPLICA_PURGE_INTERVAL:   'nsds5replicatombstonepurgeinterval',
+                                REPLICA_PURGE_DELAY:      'nsds5ReplicaPurgeDelay',
+                                REPLICA_REFERRAL:         'nsds5ReplicaReferral',
+                                REPLICA_FLAGS:            'nsds5flags'}
+
+####################################
+# 
+# Properties of a changelog
+#
+####################################
+CHANGELOG_NAME          = 'cl-name'
+CHANGELOG_DIR           = 'cl-dir'
+CHANGELOG_MAXAGE        = 'cl-maxage'
+CHANGELOG_MAXENTRIES    = 'cl-maxentries'
+CHANGELOG_TRIM_INTERVAL = 'cl-trim-interval'
+CHANGELOG_COMPACT_INTV  = 'cl-compact-interval'
+
+CHANGELOG_PROPNAME_TO_ATTRNAME = {CHANGELOG_NAME:          'cn',
+                                  CHANGELOG_DIR:           'nsslapd-changelogdir',
+                                  CHANGELOG_MAXAGE:        'nsslapd-changelogmaxage',
+                                  CHANGELOG_MAXENTRIES:    'nsslapd-changelogmaxentries',
+                                  CHANGELOG_TRIM_INTERVAL: 'nsslapd-changelogtrim-interval',
+                                  CHANGELOG_COMPACT_INTV:  'nsslapd-changelogcompactdb-interval',}
+
+####################################
+# 
+# Properties of an entry
+#
+####################################
+ENTRY_OBJECTCLASS     = 'objectclass'
+ENTRY_SN              = 'sn'
+ENTRY_CN              = 'cn'
+ENTRY_TYPE_PERSON     = 'person'
+ENTRY_TYPE_INETPERSON = 'inetperson'
+ENTRY_TYPE_GROUP      = 'group'
+ENTRY_USERPASSWORD    = 'userpassword'
+ENTRY_UID             = 'uid'
+
+ENTRY_TYPE_TO_OBJECTCLASS = {ENTRY_TYPE_PERSON:     ["top", "person"],
+                             ENTRY_TYPE_INETPERSON: ["top", "person", "inetOrgPerson"]}
+
+####################################
+# 
 # Properties supported by the replica agreement
 #
 ####################################
 
-RA_SCHEDULE_PROP='schedule'
-RA_TRANSPORT_PROT_PROP='transport-prot'
-RA_FRAC_EXCLUDE_PROP='fractional-exclude-attrs-inc'
-RA_FRAC_EXCLUDE_TOTAL_UPDATE_PROP='fractional-exclude-attrs-total'
-RA_FRAC_STRIP_PROP='fractional-strip-attrs'
-RA_CONSUMER_PORT='consumer-port'
-RA_CONSUMER_HOST='consumer-host'
-RA_CONSUMER_TOTAL_INIT='consumer-total-init'
-RA_TIMEOUT='timeout'
-
-RA_PROPNAME_TO_ATTRNAME = {RA_SCHEDULE_PROP:'nsds5replicaupdateschedule',
-                           RA_TRANSPORT_PROT_PROP:'nsds5replicatransportinfo',
-                           RA_FRAC_EXCLUDE_PROP:'nsDS5ReplicatedAttributeList',
-                           RA_FRAC_EXCLUDE_TOTAL_UPDATE_PROP:'nsDS5ReplicatedAttributeListTotal',
-                           RA_FRAC_STRIP_PROP:'nsds5ReplicaStripAttrs',
-                           RA_CONSUMER_PORT:'nsds5replicaport',
-                           RA_CONSUMER_HOST:'nsds5ReplicaHost',
-                           RA_CONSUMER_TOTAL_INIT:'nsds5BeginReplicaRefresh',
-                           RA_TIMEOUT:'nsds5replicatimeout'}
-
-
-            
\ No newline at end of file
+RA_NAME                 = 'name'
+RA_SUFFIX               = 'suffix'
+RA_BINDDN               = 'binddn'
+RA_BINDPW               = 'bindpw'
+RA_METHOD               = 'method'
+RA_DESCRIPTION          = 'description'
+RA_SCHEDULE             = 'schedule'
+RA_TRANSPORT_PROT       = 'transport-prot'
+RA_FRAC_EXCLUDE         = 'fractional-exclude-attrs-inc'
+RA_FRAC_EXCLUDE_TOTAL_UPDATE ='fractional-exclude-attrs-total'
+RA_FRAC_STRIP           = 'fractional-strip-attrs'
+RA_CONSUMER_PORT        = 'consumer-port'
+RA_CONSUMER_HOST        = 'consumer-host'
+RA_CONSUMER_TOTAL_INIT  = 'consumer-total-init'
+RA_TIMEOUT              = 'timeout'
+RA_CHANGES              = 'changes'
+
+RA_OBJECTCLASS_VALUE = "nsds5replicationagreement"
+
+RA_PROPNAME_TO_ATTRNAME = {RA_NAME:                 'cn',
+                           RA_SUFFIX:               'nsds5replicaroot',
+                           RA_BINDDN:               'nsds5replicabinddn',
+                           RA_BINDPW:               'nsds5replicacredentials',
+                           RA_METHOD:               'nsds5replicabindmethod',
+                           RA_DESCRIPTION:          'description',
+                           RA_SCHEDULE:             'nsds5replicaupdateschedule',
+                           RA_TRANSPORT_PROT:       'nsds5replicatransportinfo',
+                           RA_FRAC_EXCLUDE:         'nsDS5ReplicatedAttributeList',
+                           RA_FRAC_EXCLUDE_TOTAL_UPDATE:'nsDS5ReplicatedAttributeListTotal',
+                           RA_FRAC_STRIP:           'nsds5ReplicaStripAttrs',
+                           RA_CONSUMER_PORT:        'nsds5replicaport',
+                           RA_CONSUMER_HOST:        'nsds5ReplicaHost',
+                           RA_CONSUMER_TOTAL_INIT:  'nsds5BeginReplicaRefresh',
+                           RA_TIMEOUT:              'nsds5replicatimeout',
+                           RA_CHANGES:              'nsds5replicaChangesSentSinceStartup'}
+
+
+def rawProperty(prop):
+    '''
+        Return the string 'prop' without the heading '+'/'-'
+        @param prop - string of a property name
+        
+        @return property name without heading '+'/'-'
+        
+        @raise None
+    '''
+    if str(prop).startswith('+') or str(prop).startswith('-'):
+        return prop[1::]
+    else:
+        return prop
+        
+        
+def inProperties(prop, properties):
+    '''
+        Return True if 'prop' is in the 'properties' dictionary
+        Properties in 'properties' does NOT contain a heading '+'/'-', but 'prop'
+        may contain heading '+'/'-'
+        @param prop - string of a property name
+        @param properties - dictionary of properties. 
+        
+        @return True/False
+        
+        @raise None
+    '''
+    if rawProperty(prop) in properties:
+        return True
+    else:
+        return False
\ No newline at end of file
